use std::{collections::BTreeMap, sync::Arc};

use vulkano::{
    Validated, VulkanError,
    descriptor_set::{
        DescriptorSet,
        allocator::StandardDescriptorSetAllocator,
        layout::{DescriptorSetLayout, DescriptorSetLayoutBinding},
    },
};

pub trait AsDescriptorSetLayoutBindings {
    fn as_descriptor_set_layout_bindings() -> BTreeMap<u32, DescriptorSetLayoutBinding>;
}

pub trait AsDescriptorSet {
    fn as_descriptor_set(
        &self,
        descriptor_set_allocator: &Arc<StandardDescriptorSetAllocator>,
        layout: &Arc<DescriptorSetLayout>,
    ) -> Result<Arc<DescriptorSet>, Validated<VulkanError>>;
}
